
varying lowp vec4 v_color;
varying lowp vec2 v_texCoord;

uniform sampler2D u_texture;
uniform sampler2D u_texture1;
uniform sampler2D u_texture2;
uniform float u_materialShininess;

void main() {
	// no custom uniform, use u_materialShininess to pass the progression (last level completed / 255.0)
	lowp float progression = u_materialShininess;
	lowp float smoothness = 4.0 / 255.0;
		
	lowp vec4 cloudsColor = texture2D(u_texture, v_texCoord);
	lowp vec4 cloudsAlpha = texture2D(u_texture1, v_texCoord);
	lowp vec4 cloudsReveal = texture2D(u_texture2, v_texCoord);
	
    lowp float test1 = clamp(sign(progression - (cloudsReveal.a - smoothness)), 0.0, 1.0);
	cloudsAlpha.a = mix(cloudsAlpha.a, cloudsAlpha.a * (cloudsReveal.a - progression) / smoothness, test1);
    lowp float test2 = clamp(sign(progression - cloudsReveal.a), 0.0, 1.0);
	cloudsAlpha.a = mix(cloudsAlpha.a, 0.0, test2);
// fully transparent if the progression if greater than the reveal value
//	if (progression >= cloudsReveal.a) 
//	{
//		cloudsAlpha.a = 0.0;
//	}
// interpolation between 0 and cloudsAlpha.a if the progression is between reveal and reveal - smoothness
//	else if (progression > cloudsReveal.a - smoothness)
//	{
//		cloudsAlpha.a *= (cloudsReveal.a - progression) / smoothness;
//	}
// keep the translucence from the alpha channel otherwise
	
	gl_FragColor.rgb = v_color.rgb * cloudsColor.rgb;
	gl_FragColor.a = cloudsAlpha.a;
}
