varying lowp vec4 v_color;
varying lowp vec2 v_texCoord;

uniform sampler2D u_texture;

void main() {
	lowp vec3 white = vec3(1.0);	
	lowp vec3 black = vec3(0.0);	
	lowp vec4 texColor = texture2D(u_texture, v_texCoord);
	
	// Compute the luminance (x 2) of the texture fragment in a RGB color space
	lowp float luminanceX2 =  dot(texColor, vec4(0.2126, 0.7152, 0.0722, 0.0)) * 2.0;
    lowp float test = clamp(sign(luminanceX2 - 1.0), 0.0, 1.0);
		
    lowp vec3 multiply = mix(black, v_color.rgb, luminanceX2);
	lowp vec3 screen = mix(v_color.rgb, white, luminanceX2 - 1.0);
	// luminance <= 0.5 -> luminanceX2 <= 1.0 -> sign(luminanceX2 - 1.0) == 0 or -1 -> test == 0 -> multiply
	// luminance > 0.5  -> luminanceX2 > 1.0  -> sign(luminanceX2 - 1.0) == 1       -> test == 1 -> screen
	lowp vec3 overlay = mix(multiply, screen, test);
    
	lowp vec3 finalColor = mix(texColor.rgb, overlay, v_color.a);
	gl_FragColor = vec4(overlay, texColor.a);
}
